﻿//DESCRIPTION: Move 'see also' cross-refs down

(function () {


	app.findGrepPreferences = null;
	app.findGrepPreferences.findWhat = 'See also\\s.+';
	
	var par;
	var nextPar, nextParName, lastPar;

	function findIndex () {
		if (app.selection.length 
				&& app.selection[0].hasOwnProperty('parentStory') 
				&& app.selection[0].parentStory.storyType === StoryTypes.INDEXING_STORY) {
			return app.selection[0].parentStory;
		}
		if (app.documents[0].indexes.length > 0) {
			var stories = app.documents[0].stories.everyItem().getElements();
			for (var i = stories.length-1; i >= 0; i--) {
				if (stories[i].textContainers[0].parent instanceof Spread 
						&& stories[i].storyType === StoryTypes.INDEXING_STORY) {
					return stories[i];
				}
			}
		}
		return null;
	}

	function nextParagraph (par) {
		return par.characters[-1].contents === '\r' ? par.insertionPoints[-1].paragraphs[0] : null;
	}

	function previousParagraph (par) {
		return par.index !== 0 ? par.parentStory.insertionPoints[par.index - 1].paragraphs[0] : null;
	}

	var story = findIndex();
	if (!story) {
		alert ('No generated index in this document');
		exit();
	}

	while (story.characters[-1].contents == '\r') {
		story.characters[-1].contents = '';
	}

	// We have to add .+ at the end of the before-string. . .
	var re = RegExp (app.documents[0].indexGenerationOptions.beforeCrossReferenceSeparator.replace('.','\\.') + '$');
	
	var xrefs = story.findGrep();
	for (var i = xrefs.length-1; i >= 0; i--) {
		nextPar = nextParagraph (xrefs[i].paragraphs[0]);
		nextParName = nextPar.appliedParagraphStyle.name;
		while (nextPar != null && nextPar.appliedParagraphStyle.name === nextParName) {
			nextPar = nextParagraph (nextPar);
		}

		if (nextPar == null) {
			lastPar = story.paragraphs[-1];
		} else {
			lastPar = previousParagraph(nextPar);
		}
	
		par = xrefs[i].paragraphs[0];
		lastPar.insertionPoints[-1].contents = '\r';  // Add an empty paragraph after the last subtopic
		xrefs[i].move (LocationOptions.AFTER, lastPar.insertionPoints[-1]);
		lastPar.paragraphs[-1].applyParagraphStyle (lastPar.appliedParagraphStyle, false);
		
		story.recompose();
		par.contents = par.contents.replace (re, '');
	}

	while (story.characters[-1].contents == '\r') {
		story.characters[-1].contents = '';
	}

}());